import { scaleOrdinal } from 'd3';

const colorScale = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range(['#c11d1d','#eae600']);

const radiusScale = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range([50, 20]);

export const fruitBowl = (selection, props) => {
  
  const {fruits, height, width, setSelectedFruit, selectedFruit} = props;
  
  const circles = selection.selectAll('circle').data(fruits, d=>d.id);
  
  const xPosition = (d,i) => {
    //console.log(d.id);
    return i * 120 + 60;
  }
  
	circles
    .enter().append('circle')
			.attr('cx', xPosition)
			.attr('cy', height / 2)
  		//.attr('r',0)
  	.merge(circles) //Calling merge on enter returns enter and update selections
			.attr('fill', d => colorScale(d.type))
  		.attr('stroke', d => d.id===selectedFruit ? 'black' : 'none')
  		.attr('stroke-width', d => d.id===selectedFruit ? '5' : 'none')
  		.on('click', (event,d) => {
    		setSelectedFruit(d.id);
			})
  		.on('mouseover', (event,d) => {
    		setSelectedFruit(d.id);
			})
  		.on('mouseout', (event,d) => {
    		setSelectedFruit(null);
			})
  	.transition().duration(1000)	
  		.attr('cx', xPosition)
			.attr('r', d => radiusScale(d.type));
  
  circles.exit()
    .transition().duration(1000)	
			.attr('r', 0)
    .remove();
  
  
  /*
  circles
  	.attr('fill', d => colorScale(d.type))
		.attr('r', d => radiusScale(d.type));
  */	
};
